/**
 * generated by Xtext 2.27.0
 */
package no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Transition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition#getSource <em>Source</em>}</li>
 *   <li>{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition#getInput <em>Input</em>}</li>
 *   <li>{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition#getTarget <em>Target</em>}</li>
 * </ul>
 *
 * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getTransition()
 * @model
 * @generated
 */
public interface Transition extends EObject
{
  /**
   * Returns the value of the '<em><b>Source</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source</em>' reference.
   * @see #setSource(State)
   * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getTransition_Source()
   * @model
   * @generated
   */
  State getSource();

  /**
   * Sets the value of the '{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition#getSource <em>Source</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' reference.
   * @see #getSource()
   * @generated
   */
  void setSource(State value);

  /**
   * Returns the value of the '<em><b>Input</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Input</em>' attribute.
   * @see #setInput(String)
   * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getTransition_Input()
   * @model
   * @generated
   */
  String getInput();

  /**
   * Sets the value of the '{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition#getInput <em>Input</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Input</em>' attribute.
   * @see #getInput()
   * @generated
   */
  void setInput(String value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(State)
   * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getTransition_Target()
   * @model
   * @generated
   */
  State getTarget();

  /**
   * Sets the value of the '{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(State value);

} // Transition
